# test mod for wozabee's sun animation model, June 2011

=begin
Copyright(C) 2010, kyyu
All Rights Reserved
Permission to use, copy, modify, and distribute this software for any purpose
and without fee is hereby granted, provided this notice appears in any copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Name:      		Key Rotate
Version:   		1.02
SU Version:   	7.0
Date:      		05-04-2010

Purpose:		This plugin helps with the assembly of 3D models & puzzles for 1/4" sheet stock.
Description:   	Mouse over a group and use keyboard keys to rotate group 90 deg (about their center)
Usage:      	
	# Right & Left arrow keys => rotate about the green (Y) axis direction
	# Up & Down arrow keys => rotate about the red (X) axis direction
	# Home & End arrow keys => rotate about the blue (Z) axis direction
    # ** Hold Shift Key to add to selection
	
Credits:		I learned alot buy studying TBD's Rotix plugin.  Thanks you, for making it!
History:
			1.0 	(05-04-2010)  -  first version
			1.01-2	added to description text

=end

require 'sketchup.rb'

class KyyuKeyRotate

   def activate
      @selected = []
	  @group_already = 0
	  @add_selection = 0
	  @sel = Sketchup.active_model.selection
      Sketchup::set_status_text('Key Rotate - press shift key to add to selection', SB_PROMPT)
   end
   
      #perform rotation around X axis
   def rotate_X(angle)
      @sel.each do |e|  
         # pt = e.bounds.center
				 pt = [0,0,0]
              v = Geom::Vector3d.new(1,0,0)
         tr = Geom::Transformation.rotation(pt,v,angle.degrees)
         Sketchup.active_model.active_entities.transform_entities(tr,e)
      end
   end

      #perform rotation around Y axis
   def rotate_Y(angle)
      @sel.each do |e|  
         # pt = e.bounds.center
				 pt = [0,0,0]
              #v = Geom::Vector3d.new(0,1,0)
							v = Geom::Vector3d.new(0,0,1)
         tr = Geom::Transformation.rotation(pt,v,angle.degrees)
         Sketchup.active_model.active_entities.transform_entities(tr,e)
      end
   end
   
     #perform rotation around z axis
   def rotate_Z(angle)
      @sel.each do |e|  
         pt = e.bounds.center
              # v = Geom::Vector3d.new(0,0,1)
							v = Geom::Vector3d.new(0,-1,0)
         tr = Geom::Transformation.rotation(pt,v,angle.degrees)
         Sketchup.active_model.active_entities.transform_entities(tr,e)
      end
   end
   
   
 # on MouseMove perform selection
   def onMouseMove(flags, x, y, view)  
      ph = view.pick_helper
      found = ph.do_pick(x,y)
      picked = ph.best_picked 

      if (picked != nil)
         # do not add edges/faces to selection
          if (!picked.kind_of? Sketchup::Edge and !picked.kind_of? Sketchup::Face and (@group_already != 1 or @add_selection == 1))
            Sketchup.active_model.selection.add(picked)
            @selected = picked
			@group_already = 1
          end
		  if (@selected != picked and @add_selection == 0)
			Sketchup.active_model.selection.clear
			@group_already = 0
		  end		  
      elsif (@add_selection == 0)
          Sketchup.active_model.selection.clear
          @selected = nil
		  @group_already = 0
      end
   end

   # if SHIFT is released back to normal selection (on mouse hover)
   def onKeyUp(key, repeat, flags, view)
      @add_selection = 0 if key == CONSTRAIN_MODIFIER_KEY
   end
   
      # process keyboard
   def onKeyDown(key, repeat, flags, view)
	  case key
         when VK_LEFT then rotate_Y(-1)
         when VK_RIGHT then rotate_Y(1)
         when VK_UP then rotate_X(-1)
         when VK_DOWN then rotate_X(1)
		 when VK_HOME then rotate_Z(1)
         when VK_END then rotate_Z(-1)
         when CONSTRAIN_MODIFIER_KEY then @add_selection = 1 if (repeat == 1)
      end
   end

   

      
end		# end class KyyuKeyRotate

#----------------------------------------------------------------------------
# add menu items

if( not file_loaded?('ky_Key Rotate.rb') )
	if $kyyu_submenu == 1
		$kyyu_PlugName.add_item('Key Rotate') { Sketchup.active_model.select_tool KyyuKeyRotate.new }
	else
		$kyyu_PlugName=UI.menu('Plugins').add_submenu('[kyyu]')
		$kyyu_PlugName.add_item('Key Rotate') { Sketchup.active_model.select_tool KyyuKeyRotate.new }
		$kyyu_submenu = 1
	end
end

# if( not file_loaded?('ky_Key Rotate.rb') )
  # UI.menu('Plugins').add_item('[ky] Key Rotate') { Sketchup.active_model.select_tool KyyuKeyRotate.new }
# end

file_loaded 'ky_Key Rotate.rb'


